package com.fp.persistence.parmas.soli;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMGUARDIAS*/
@Entity(name="TarmGuardias")
@Table(name="TARMGUARDIAS")
public class TarmGuardias extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmGuardias
*/
@Id
@Column(name="CGUARDIA" ,nullable=false, updatable=false)
private Integer pk;
@Column(name="CEMPRESA", nullable=true)

/**
* Codigo de persona
*/
private Integer cempresa;

@Column(name="ESTADO", nullable=true)

/**
* null
*/
private String estado;

/**Contructor por defecto*/
public TarmGuardias(){
}
/**Contructor de TarmGuardias
@param pPk Clave Primaria del entity
*/
public TarmGuardias(Integer pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmGuardias
*/
public static TarmGuardias find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmGuardias obj = pEntityManager.find(TarmGuardias.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmGuardias
@return El objeto que referencia a la Clave primaria de TarmGuardias
*/
public Integer getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmGuardias
@param pPk El objeto que referencia a la nueva Clave primaria de TarmGuardias
*/
public void setPk(Integer pPk){
  pk=pPk;
}
/**Obtiene el valor de cempresa
@return valor de cempresa*/
public Integer getCempresa(){
  return cempresa;
}
/**Fija el valor de cempresa
@param pCempresa nuevo Valor de cempresa*/
public void setCempresa(Integer pCempresa){
  cempresa=pCempresa;
}

/**Obtiene el valor de estado
@return valor de estado*/
public String getEstado(){
  return estado;
}
/**Fija el valor de estado
@param pEstado nuevo Valor de estado*/
public void setEstado(String pEstado){
  estado=pEstado;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmGuardias))return false;
    TarmGuardias that = (TarmGuardias) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmGuardias
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmGuardias
*/
public Object createInstance(){
 TarmGuardias instance=new TarmGuardias();	
 return instance;
}
/**Clona la entidad TarmGuardias
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmGuardias p=(TarmGuardias)this.clone();
  return p;
}
}
